
<form [formGroup]="formGroup">
  <cui-form-field label="Reactive forms test">
    <cui-input-text formControlName="name1"></cui-input-text>
  </cui-form-field>
</form>


<div class="container">
  <form [formGroup]="form" (ngSubmit)="onSubmit(model)">
    <formly-form [form]="form" [fields]="fields" [model]="model"></formly-form>
    <button cui-button type="submit" class="btn btn-default">Submit</button>
  </form>
</div>

<div class="container">
  <cui-tabs #mytabs="tabs">
    <cui-tab label="Menu 1" [cui-menu-trigger]="tabmenu"></cui-tab>
    <cui-tab [label]="'Change ' + count" [template]="tabActivity"></cui-tab>
    <cui-tab label="Inactive" prefixIcon="delete" [disabled]="true">Profile Tab</cui-tab>
    <cui-tab label="Network" [template]="tabNetwork" class="cui-d-none:m"></cui-tab>
    <cui-tab label="Extra" #tab2="tab" suffixIcon="globe">Extra Tab</cui-tab>
    <cui-tab #urltab="tab" label="Link" [url]="str" [urlActive]="active"></cui-tab>
    <cui-tab #tab1="tab">MENU 1</cui-tab>
    <cui-tab label="Lorem Ipsum dolor sit amet">Lorem Ipsum dolor sit amet</cui-tab>
    <ng-template #tabActivity>
      <app-content name="activity tab"></app-content>
    </ng-template>
    <ng-template #tabNetwork>
      <app-content name="network tab"></app-content>
    </ng-template>
    <cui-menu #tabmenu="menu">
      <button cui-menu-item [cui-tab-handle]="tab2">Extra</button>
      <button cui-menu-item [cui-tab-handle]="urltab">Menu Url</button>
      <button cui-menu-item [cui-tab-handle]="tab1">Menu 1</button>
    </cui-menu>
  </cui-tabs>
</div>

<button (click)="active = !active">activate</button>
<button (click)="count = count + 1">increment</button>
<button (click)="str = str + '/foo'">more</button>

<div class="container navigation-container">
  <cui-navigation-card-demo></cui-navigation-card-demo>
</div>

<div class="hover-demo">
  <div class="hover-content">
    Hello World!
  </div>
</div>

<div class="container">
  <cui-form-field label="Clearable Search Field">
    <cui-icon name="search" cuiFormPrefix></cui-icon>
    <cui-input-text [clearable]="true" [(ngModel)]="disabledFieldValue"></cui-input-text>
  </cui-form-field>
</div>

<cui-card>
  <cui-card-header>
    <h2>Hello World</h2>
    <cui-card-menu>
      <button cui-menu-item
              prefixIcon="pencil">
        EDIT
      </button>
      <button cui-menu-item
              prefixIcon="pencil">
        PRINT
      </button>
      <hr/>
      <button cui-menu-item
              class="cui-text-error">
        DELETE
      </button>
    </cui-card-menu>
  </cui-card-header>
</cui-card>

<a cui-button mode="primary" look="link">Test button link</a>

<cui-scrollable style="max-width: 200px; max-height: 200px;">
  Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore
  magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd
  gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing
  elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos
  et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor
  sit amet.
</cui-scrollable>

<button cui-button [cui-sidebar-trigger]="sidenav">Open Sidenav</button>
<cui-sidebar
  #sidenav
  direction="left"
  [barWidth]="15">
  <div style="padding: 1rem">
    <div>
      <button cui-button mode="ghost">Item 1</button>
    </div>
    <div>
      <button cui-button mode="ghost">Item 2</button>
    </div>
  </div>
</cui-sidebar>

<div class="container">
  <button cui-button mode="primary" aria-label="Sample button"
          [cuiTooltip]="tooltipHTML" [cuiTooltipAllowHtml]="true">Tooltip Multi Line
  </button>
</div>
<div class="container">
  <button cui-button
          (click)="collapse.toggle()" [suffixIcon]="!collapsed ? 'eye-solid' : 'eye-outlined'">
    Toggle Collapse
  </button>
  <div class="collapsable-container"
       [(cuiCollapse)]="collapsed"
       #collapse="cuiCollapse"
       (shown)="collapsableShown()"
       (hidden)="collapsableHidden()">
    <div class="collapsable-content">
      Collapsible content
    </div>
  </div>
</div>

<div class="container">
  <div cuiCustomPalette="#ff0000">
    <h3>Red theme</h3>
    <button cui-button>Button 1</button>
    <br><br>
    <button cui-button>Button 2</button>
  </div>
</div>

<div class="container">
  <button cui-button mode="primary" [cui-menu-trigger]="menu">Show menu</button>
  <cui-menu #menu="menu" (onHidden)="log('menu hidden')">
    <button cui-menu-item [active]="true">Active</button>
    <span cui-menu-title>Options</span>
    <button cui-menu-item [cui-menu-trigger]="submenu">Show Submenu</button>
    <button cui-menu-item [disabled]="true" [cui-menu-trigger]="submenu2">Show Submenu 2</button>
    <button cui-menu-item [cui-menu-trigger]="submenu3">Show Submenu</button>
    <button cui-menu-item [disabled]="true">Share</button>
    <hr>
    <button cui-menu-item prefixIcon="delete">Delete</button>
  </cui-menu>
  <cui-menu #submenu="menu">
    <button cui-menu-item [active]="true">Active</button>
    <span cui-menu-title>Options</span>
    <button cui-menu-item [disabled]="true">Share</button>
    <hr>
    <button cui-menu-item prefixIcon="delete">Delete</button>
  </cui-menu>
  <cui-menu #submenu2="menu">
    <button cui-menu-item [active]="true">Active</button>
    <span cui-menu-title>Options</span>
    <button cui-menu-item [disabled]="true">Share</button>
    <hr>
    <button cui-menu-item prefixIcon="delete">Delete</button>
  </cui-menu>
  <cui-menu #submenu3="menu">
    <button cui-menu-item [active]="true">Active</button>
    <span cui-menu-title>Options</span>
    <button cui-menu-item [disabled]="true">Share</button>
    <hr>
    <button cui-menu-item prefixIcon="delete">Delete</button>
  </cui-menu>
</div>

<div class="container">
  <h3>fileName pipe</h3>
  <p>
    stripExt: true , StripPath: false (default)<br>
    http://www.test.com/test.jpg: {{ 'http://www.test.com/test.tar.gz' | fileName }}
  </p>
  <p>
    stripExt: true , stripPath: true<br>
    http://www.test.com/test.jpg -> {{ 'http://www.test.com/test.tar.gz' | fileName : {
    stripExt: true,
    stripPath: true
  } }}
  </p>
  <p>
    stripExt: false , stripPath: false<br>
    http://www.test.com/test.tar.gz -> {{ 'http://www.test.com/test.tar.gz' | fileName : {
    stripExt: true,
    stripPath: false
  } }}
  </p>
  <p>
    stripExt: false , stripPath: true<br>
    http://www.test.com/test.tar.gz -> {{ 'http://www.test.com/test.tar.gz' | fileName : {
    stripExt: false,
    stripPath: false
  } }}
  </p>
  <p>
    stripExt: false , stripPath: true<br>
    http://www.test.com/test/test.jpb -> {{ 'http://www.test.com/test.jpg' | fileName : {
    stripExt: false,
    stripPath: true
  } }}
  </p>
  <p>
    stripExt: false , stripPath: false<br>
    test.jpg -> {{ 'test.jpg' | fileName : { stripExt: false, stripPath: false } }}
  </p>
  <p>
    stripExt: true , stripPath: true<br>
    test.jpg -> {{ 'test.jpg' | fileName : { stripExt: true, stripPath: true } }}
  </p>

  <h3>fileSize pipe</h3>
  <p>1024 Bytes (with separator): {{ '1024' | fileSize : ' ' }}</p>
  <p>1024000 Bytes: {{ '1024000' | fileSize }}</p>
  <p>1024000000 Bytes (with separator): {{ '1024000000' | fileSize : ' ' }}</p>
  <p>5024000000 Bytes: {{ '5024000000' | fileSize }}</p>
  <p>5024000000000 Bytes: {{ '5024000000000' | fileSize }}</p>
  <p>5024000000000000 Bytes: {{ '5024000000000000' | fileSize }}</p>
  <p>0 Bytes: {{ '0' | fileSize }}</p>
  <p>3433352 Bytes: {{ '3433352' | fileSize }}</p>

  <h3>fileIcon pipe</h3>
  <p>
    Default Set, application/pdf: {{ 'application/pdf' | fileIcon }}
    <cui-icon [name]="'application/pdf' | fileIcon"></cui-icon>
  </p>
  <p>
    Google Set, application/pdf: {{ 'application/pdf' | fileIcon:'google' }}
    <cui-icon [name]="'application/pdf' | fileIcon:'google'"></cui-icon>
  </p>
  <p>
    Google Set, invalid mime type: {{ 'invalid/mime' | fileIcon: 'google' }}
    <cui-icon [name]="'invalid/mime' | fileIcon: 'google'"></cui-icon>
  </p>
  <p>
    Invalid Mime Type: {{ 'invalid/mime' | fileIcon }}
    <cui-icon [name]="'invalid/mime' | fileIcon"></cui-icon>
  </p>
</div>

<button cui-button mode="primary" [cui-popover-trigger]="popover">Show popover</button>
<cui-popover #popover="popover" [template]="popoverContent"></cui-popover>
<ng-template #popoverContent>
  <app-content name="popover"></app-content>
</ng-template>

<button cui-button mode="primary" [cui-menu-trigger]="menu">Show menu</button>
<cui-menu #menu="menu">
  <button cui-menu-item [active]="true">Active</button>
  <span cui-menu-title>Options</span>
  <button cui-menu-item [cui-menu-trigger]="submenu">Show Submenu</button>
  <button cui-menu-item [disabled]="true" [cui-menu-trigger]="submenu2">Show Submenu 2</button>
  <button cui-menu-item [cui-menu-trigger]="submenu3">Show Submenu</button>
  <button cui-menu-item [disabled]="true">Share</button>
  <hr>
  <button cui-menu-item prefixIcon="delete">Delete</button>
</cui-menu>
<cui-menu #submenu="menu">
  <button cui-menu-item [active]="true">Active</button>
  <span cui-menu-title>Options</span>
  <button cui-menu-item [disabled]="true">Share</button>
  <hr>
  <button cui-menu-item prefixIcon="delete">Delete</button>
</cui-menu>
<cui-menu #submenu2="menu">
  <button cui-menu-item [active]="true">Active</button>
  <span cui-menu-title>Options</span>
  <button cui-menu-item [disabled]="true">Share</button>
  <hr>
  <button cui-menu-item prefixIcon="delete">Delete</button>
</cui-menu>
<cui-menu #submenu3="menu">
  <button cui-menu-item [active]="true">Active</button>
  <span cui-menu-title>Options</span>
  <button cui-menu-item [disabled]="true">Share</button>
  <hr>
  <button cui-menu-item prefixIcon="delete">Delete</button>
</cui-menu>

<h3>fileName pipe</h3>
<p>
  stripExt: true , StripPath: false (default)<br>
  http://www.test.com/test.jpg: {{ 'http://www.test.com/test.tar.gz' | fileName }}
</p>
<p>
  stripExt: true , stripPath: true<br>
  http://www.test.com/test.jpg -> {{ 'http://www.test.com/test.tar.gz' | fileName : {
  stripExt: true,
  stripPath: true
} }}
</p>
<p>
  stripExt: false , stripPath: false<br>
  http://www.test.com/test.tar.gz -> {{ 'http://www.test.com/test.tar.gz' | fileName : {
  stripExt: true,
  stripPath: false
} }}
</p>
<p>
  stripExt: false , stripPath: true<br>
  http://www.test.com/test.tar.gz -> {{ 'http://www.test.com/test.tar.gz' | fileName : {
  stripExt: false,
  stripPath: false
} }}
</p>
<p>
  stripExt: false , stripPath: true<br>
  http://www.test.com/test/test.jpb -> {{ 'http://www.test.com/test.jpg' | fileName : {
  stripExt: false,
  stripPath: true
} }}
</p>
<p>
  stripExt: false , stripPath: false<br>
  test.jpg -> {{ 'test.jpg' | fileName : { stripExt: false, stripPath: false } }}
</p>
<p>
  stripExt: true , stripPath: true<br>
  test.jpg -> {{ 'test.jpg' | fileName : { stripExt: true, stripPath: true } }}
</p>

<h3>fileSize pipe</h3>
<p>1024 Bytes (with separator): {{ '1024' | fileSize : ' ' }}</p>
<p>1024000 Bytes: {{ '1024000' | fileSize }}</p>
<p>1024000000 Bytes (with separator): {{ '1024000000' | fileSize : ' ' }}</p>
<p>5024000000 Bytes: {{ '5024000000' | fileSize }}</p>
<p>5024000000000 Bytes: {{ '5024000000000' | fileSize }}</p>
<p>5024000000000000 Bytes: {{ '5024000000000000' | fileSize }}</p>
<p>0 Bytes: {{ '0' | fileSize }}</p>
<p>3433352 Bytes: {{ '3433352' | fileSize }}</p>

<h3>fileIcon pipe</h3>
<p>
  Default Set, application/pdf: {{ 'application/pdf' | fileIcon }}
  <cui-icon [name]="'application/pdf' | fileIcon"></cui-icon>
</p>
<p>
  Google Set, application/pdf: {{ 'application/pdf' | fileIcon:'google' }}
  <cui-icon [name]="'application/pdf' | fileIcon:'google'"></cui-icon>
</p>
<p>
  Google Set, invalid mime type: {{ 'invalid/mime' | fileIcon: 'google' }}
  <cui-icon [name]="'invalid/mime' | fileIcon: 'google'"></cui-icon>
</p>
<p>
  Invalid Mime Type: {{ 'invalid/mime' | fileIcon }}
  <cui-icon [name]="'invalid/mime' | fileIcon"></cui-icon>
</p>

<div class="radio-container">
  <cui-radio-group [formControl]="radioControl">
    <cui-radio-button value="ok">ok</cui-radio-button>
    <cui-radio-button value="not">not</cui-radio-button>
  </cui-radio-group>
  <div class="selected-radio-value">
    Selected Radio: {{radioControl.value}}
  </div>
</div>

<div class="container">
  <cui-form-field label="Disabled Text Field">
    <cui-input-text [(ngModel)]="disabledFieldValue" [disabled]="true"></cui-input-text>
  </cui-form-field>
</div>

<div class="self-saving-fields-container">
  <div class="self-saving-field">
    <cui-form-field label="Self Saving Number Field With 5 seconds debounce" cuiFormSelfSave
                    mode="primary"
                    [saveDebounceTime]="3000"
                    [saveFn]="backendSaveSimulation('number')">
      <cui-input-number [formControl]="selfSavingControl"></cui-input-number>
    </cui-form-field>
  </div>

  <div class="self-saving-field">
    <cui-form-field label="Self Saving Password Field With Custom Icons" cuiFormSelfSave
                    mode="ghost"
                    [saveFn]="backendSaveSimulation('password')" [successIcon]="'chevron-left'"
                    [errorIcon]="'chevron-right'">
      <cui-input-password [formControl]="selfSavingControl"></cui-input-password>
    </cui-form-field>
  </div>

  <div class="self-saving-field">
    <cui-form-field label="Self Saving Text Field" cuiFormSelfSave [saveFn]="backendSaveSimulation('text')"
                    mode="secondary">
      <cui-input-text [formControl]="selfSavingControl" [disabled]="true"></cui-input-text>
    </cui-form-field>
  </div>

  <div class="self-saving-field">
    <cui-form-field label="Self Saving Textarea Field" cuiFormSelfSave [saveFn]="backendSaveSimulation('textarea')">
      <cui-input-textarea [formControl]="selfSavingControl"></cui-input-textarea>
    </cui-form-field>
  </div>

  <div class="self-saving-field">
    <cui-form-field label="Self Saving Timepicker Field" cuiFormSelfSave
                    [saveFn]="backendSaveSimulation('timepicker')">
      <cui-input-timepicker [formControl]="selfSavingControl"></cui-input-timepicker>
    </cui-form-field>
  </div>

  <div class="self-saving-field">
    <cui-form-field label="Self Saving Datepicker Field" cuiFormSelfSave
                    [saveFn]="backendSaveSimulation('datepicker')">
      <cui-input-datepicker [formControl]="selfSavingControl"></cui-input-datepicker>
    </cui-form-field>
  </div>
</div>

<form>
  <div class="container">
    <label class="mat-label" for="toggle1-input">
      External Label for Toggle
    </label>
    <cui-toggle id="toggle1">
      Toggle Internal Label
    </cui-toggle>

  </div>

  <div class="radio-container">
    <label class="mat-label" for="radio1-input">
      External Label for Radio 1
    </label>
    <cui-radio-group [formControl]="radioControl">
      <cui-radio-button value="ok" id="radio1">ok</cui-radio-button>
      <cui-radio-button value="not" id="radio2">not</cui-radio-button>
    </cui-radio-group>
    <label class="mat-label" for="radio2-input">
      External Label for Radio 2
    </label>
    <div class="selected-radio-value">
      Selected Radio: {{radioControl.value}}
    </div>
  </div>

  <label class="mat-label" for="testingCheckbox-input">
    External Label for checkbox
  </label>
  <cui-checkbox [formControl]="bool" (change)="onChange($event)"
                id="testingCheckbox"
                (indeterminateChange)="onIndeterminateChange($event)"
                [indeterminate]="true">Hello World<br>dsfsdf
  </cui-checkbox>
  <cui-checkbox [formControl]="bool" [disabled]="true" [align]="'right'">Hello World<br>dsfsdf</cui-checkbox>
  <cui-form-field label="Select (S)" size="s">
    <cui-select [formControl]="name5" [items]="items" bindLabel="name" placeholder="sfdsfdsf"></cui-select>
  </cui-form-field>
  <cui-form-field label="Select (M)" size="m">
    <cui-select [formControl]="name5" [items]="items" bindLabel="name" placeholder="sfdsfdsf"></cui-select>
  </cui-form-field>
  <cui-form-field label="Select (L)" size="l">
    <cui-select [formControl]="name5" [items]="items" bindLabel="name" placeholder="sfdsfdsf"></cui-select>
  </cui-form-field>
  <cui-form-field label="Select (S - multi)" size="s">
    <cui-select [formControl]="name6" [items]="items" bindLabel="name" [multiple]="true"
                placeholder="sfdsfdsf"></cui-select>
  </cui-form-field>
  <cui-form-field label="Select (M - multi)" size="m">
    <cui-select [formControl]="name6" [items]="items" bindLabel="name" [multiple]="true"
                placeholder="sfdsfdsf"></cui-select>
  </cui-form-field>
  <cui-form-field label="Select (L - multi)" size="l">
    <cui-icon name="align-center" size="xl" cuiFormInfo></cui-icon>
    <cui-select [formControl]="name6" [items]="items" bindLabel="name" [multiple]="true"
                placeholder="sfdsfdsf"></cui-select>
  </cui-form-field>
  <cui-form-field label="Select (tag)" size="m">
    <cui-select [formControl]="name7" [items]="items" bindLabel="name" [addTag]="true"
                [multiple]="true"></cui-select>
  </cui-form-field>

  <cui-form-field label="test a11y without hint">
    <cui-input-text></cui-input-text>
  </cui-form-field>

</form>

<button cui-button (click)="openDialog()">Open dialog</button>
